package com.perforce.cvs;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class RevisionSorter {

	private int index = 0;
	private List<DBRevisionWrapper> list = new ArrayList<DBRevisionWrapper>();

	public void add(RevisionEntry entry) {
		DBRevisionWrapper wrap = new DBRevisionWrapper(entry);
		list.add(wrap);
	}
	
	public void sort() {
		Collections.sort((List<DBRevisionWrapper>) list);
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		for (DBRevisionWrapper wrap : list) {
			sb.append(wrap.get().toString());
			sb.append("\n");
		}
		return sb.toString();
	}

	public RevisionEntry next() {
		if (hasNext()) {
			DBRevisionWrapper wrap = list.get(index);
			RevisionEntry entry = wrap.get();
			index++;
			return entry;
		}
		return null;
	}

	public boolean hasNext() {
		return (index < list.size());
	}

	public boolean isEmpty() {
		return list.isEmpty();
	}

	public void drop() {
		if (index > 0) {
			index--;
		}
		list.remove(index);
	}

	public void reset() {
		index = 0;
	}
}
